
//                          EASY DST CLOCK NORTHERN HEMISPHERE
//********************************LAST UPDATE DEC 8, 2019******************************************
//Easy_DST_Clock

#include "LedControl.h"                           //LIBRARIES
#include <Wire.h>
#include <LCD.h>
#include <LiquidCrystal_I2C.h>

LedControl lc=LedControl(12,11,10,1); 
LiquidCrystal_I2C  lcd(0x27,2,1,0,4,5,6,7);

const int buttonPinm = 2;                         //pushbutton pin minutes
const int buttonPins = 3;                         //pushbutton pin seconds
const int buttonPinh = 4;
unsigned long previousMasterTime = 0;             //Master clock previous count
unsigned long previousMasterTimeSt = 0;           //Standard clock previous count
unsigned long previousMicroTime = 0;
unsigned long previousMicroTimeSt = 0;


int DSTtime = 0;                                  //DST Clock Seconds
int masterTimeSt = 0;                             //Standard Clock seconds
int minuteSt = 20;                                //Standard Clock minutes
int hourSt = 21;                                   //Standard Clock hourd 
int DSTdays = 4;                                // DST Clock daylight savings offset
int DSTyear = 2020;                               //DST Clock Year
int readingm = 0;                                 //Adjust minute variable
int readings = 0;                                 //Adjust seconds variable
int readingh = 0;                                 //Adjust hours variable
int STDhour = 0;
int displayTimeScale = 0;                        // Switch between 12 and 24 hour clocks

              //0 to 365 day off-set array
int DSTday[]                                   
              {0,0,0,1,1,1,2,2,2,3,3,3,4,4,4,5,5,5,6,6,6,7,7,7,8,8,8,9,9,9,                                    //Dec 21 to Jan 19 -     30
              10,10,10,11,11,11,12,12,12,13,13,13,14,14,14,15,15,15,16,16,16,17,17,17,18,18,18,19,19,19,       //Jan 20 to Feb 18 -     30
              20,20,20,21,21,21,22,22,22,23,23,23,24,24,24,25,25,25,26,26,26,27,27,27,28,28,28,29,29,29,30,    //Feb 19 to Mar 20 -     31
              30,30,31,31,31,32,32,32,32,33,33,33,34,34,34,35,35,35,36,36,36,37,37,37,38,38,38,39,39,39,       //Mar 21 to Apr 20 -     30
              40,40,40,41,41,41,42,42,42,43,43,43,44,44,44,45,45,45,46,46,46,47,47,47,48,48,48,49,49,49,       //Apr 21 to May 19 -     30
              50,50,50,51,51,51,52,52,52,53,53,53,54,54,54,55,55,55,56,56,56,57,57,57,58,58,58,59,59,59,       //May 20 to June 18 -    30
              60,60,60,60,60,59,59,59,58,58,58,57,57,57,56,56,56,55,55,55,54,54,54,53,53,53,52,52,52,51,51,    //June 19 to July 19 -   31
              51,50,50,50,49,49,49,48,48,48,47,47,47,46,46,46,45,45,45,44,44,44,43,43,43,42,42,42,41,41,       //July 20 to Aug 19 -    30
              41,40,40,40,39,39,39,38,38,38,37,37,37,36,36,36,35,35,35,34,34,34,33,33,33,32,32,32,31,31,       //Aug 20 to Sept 18 -    30
              31,30,30,30,29,29,29,28,28,28,27,27,27,26,26,26,25,25,25,24,24,24,23,23,23,22,22,22,21,21,21,    //Sept 19 to Oct 19 -    31
              20,20,20,19,19,19,18,18,18,17,17,17,16,16,16,15,15,15,14,14,14,13,13,13,12,12,12,11,11,11,       //Oct 20 to Nov 18 -     30
              10,10,10,9,9,9,8,8,8,7,7,7,6,6,6,5,5,5,4,4,4,3,3,3,2,2,2,1,1,1,0,0,0,0};                         //Nov 19 to Dec 20 -     34
                                                                                                                              // TOTAL 367
int DSTminute = minuteSt;                               //DST Clock minutes
int DSThour = hourSt;                                   //DST Clock hours 
 
void setup() {                                    //Set up Constants on display
Serial.begin(9600);
  pinMode(buttonPinm, INPUT);
  pinMode(buttonPins, INPUT);
  pinMode(buttonPinh, INPUT);
  lcd.begin (16,2);                              // start 16 x 2 LCD module
  lcd.clear();                                    
  lcd.setBacklightPin(3,POSITIVE);                
  lcd.setBacklight(HIGH);                         

  lcd.setCursor(0,0);                             
  lcd.print("STD");                               
  lcd.setCursor(6,0);                             //Display constants on LCD display
  lcd.print(":");                                 
  lcd.setCursor(9,0);                            
  lcd.print(":");                                 

  lcd.setCursor(0,1);                             
  lcd.print("DST");                               
  lcd.setCursor(6,1);                             
  lcd.print(":");                                 
  lcd.setCursor(9,1);                            
  lcd.print(":");                                 

  DSTminute = DSTminute + DSTday[DSTdays];        //Start minute plus off-set
 if (DSTminute >= 60){
    DSTminute = DSTminute - 60;
    DSThour++;
  } 
  Serial.println(DSTdays);
}




void loop() {
unsigned long masterTime = millis();                //Master clock counter in milliseconds
unsigned long microTime = micros();                 //Master clock counter in microseconds

        //Compare difference from last second
if ((masterTime - previousMasterTimeSt >=1000) && (microTime - previousMicroTimeSt >= 1000637)){    //Adjust in micro-seconds
      masterSt();                                 //Call standard time display
    masterTimeSt++;                               //Add a second to standard time
    DSTtime++;                                    //Increment DST time   
  previousMasterTimeSt = masterTime;              //Update previous time counter in milliseconds
  previousMicroTimeSt = microTime;                //Update previous time counter in microseconds
  }   

}




void masterSt(){                                   //Time keeping function
  

  readings = digitalRead(buttonPins);               //Press button #1 to adjust seconds
  if(readings >> 0){
    masterTimeSt++;
    DSTtime++;
  }
     readingm = digitalRead(buttonPinm);            //Press button #2 to adjust minutes
  if(readingm >> 0){
    minuteSt++;
    DSTminute++;
  }
  readingh = digitalRead(buttonPinh);               //Press button #3 to adjust hours
  if(readingh >> 0){
    hourSt++;
    DSThour++;
  }
  
  
  if (masterTimeSt >= 60){                    //Check value of seconds  
    masterTimeSt = 0;                              //Reset seconds to zero
    minuteSt++;                                    //Increment minutes  
  }
  if(masterTimeSt <=9){                                 //Display master clock seconds
    lcd.setCursor(10,0); 
    lcd.print("0"); 
    lcd.setCursor(10,1);                           
    lcd.print("0");                                
    lcd.setCursor(11,0);                           
    lcd.print(masterTimeSt);
    lcd.setCursor(11,1);
    lcd.print(masterTimeSt);                       
  }
  else{
    lcd.setCursor(10,0);                           
    lcd.print(masterTimeSt);    
    lcd.setCursor(10,1);                           
    lcd.print(masterTimeSt);                    
  }

  
    if (DSTtime >= 60){                       //Check value of DST seconds                
    DSTtime = 0;                                   //Reset seconds to zero
    DSTminute++;                                   //Increment DST minutes         
  }
  if(DSTtime <=9){                                      //Display DST clock seconds
    lcd.setCursor(10,1);                           
    lcd.print("0");                                
    lcd.setCursor(11,1);                           
    lcd.print(DSTtime);                            
  }
  else{
    lcd.setCursor(10,1);                          
    lcd.print(DSTtime);                           
  }
  if (minuteSt >= 60){                         //Check value of minutes
    minuteSt = 0;                                  //Reset minutes to zero
    hourSt++;                                      //Increment hour ******************************************        
  }
  if (minuteSt <= 9){                                   //Display master clock minutes
    lcd.setCursor(7,0);                            
    lcd.print("0");                                
    lcd.setCursor(8,0);                            
    lcd.print(minuteSt);                           
  }
  else{
    lcd.setCursor(7,0);                            
    lcd.print(minuteSt);                           
  }


  if (DSTminute >= 60){                       //Check value of DST minute                           ***
    DSTminute = 0;                                   //Reset DST minute to zero
    DSThour++;                                       //Increment DST hour 
  }
  if (DSTminute <= 9){                                      //Display DST clock minute
    lcd.setCursor(7,1);
    lcd.print("0");
    lcd.setCursor(8,1);
    lcd.print(DSTminute);
  }
  else{
    lcd.setCursor(7,1);
    lcd.print(DSTminute);
  }
readingm = 0;                                               //Reset push button #2 value to zero  MINUTES
readings = 0;                                               //Reset push button #1 value to zero  SECONDS
 //***********************************************************************************************************

  if(hourSt == 0){
      STDhour = 12;
      lcd.setCursor(4,0);
      lcd.print(STDhour);
    }
  if((hourSt >= 1) && (hourSt <= 9)){
    STDhour = hourSt;
    lcd.setCursor(4,0);
    lcd.print(" ");
    lcd.setCursor(5,0);
    lcd.print(STDhour);
  }
  if((hourSt >= 10) && (hourSt <= 12)){
    STDhour = hourSt;
    lcd.setCursor(4,0);
    lcd.print(STDhour);
  }
  if((hourSt >= 13) && (hourSt <= 21)){
    STDhour = hourSt - 12;
    lcd.setCursor(4,0);
    lcd.print(" ");
    lcd.setCursor(5,0);
    lcd.print(STDhour);
  }
  if((hourSt >= 22) && (hourSt <= 23)){
    STDhour = hourSt - 12;
    lcd.setCursor(4,0);
    lcd.print(STDhour);
  }
  if (hourSt >= 24){                             //Check value of standard clock hour
  hourSt = 0;                                         //Reset hour to zero
  DSTdays++;                                          //Increment DST array 
  //lcd.setCursor(13,1);
  //lcd.print("   "); 
  DSTminute = minuteSt + DSTday[DSTdays];                              
 }
 
//***********************************************************************************************************
  if(DSThour >=24){
    DSThour = 0;
    //DSTdays++;
  }
   if (DSThour <= 9){                               //Display DST hour
    lcd.setCursor(4,1);
    lcd.print("0");
    lcd.setCursor(5,1);                            
    lcd.print(DSThour);
  }
  else{
    lcd.setCursor(4,1);                            
    lcd.print(DSThour);                            
  }

  if (DSTdays >= 367){                                //Detect end of year
    DSTday[DSTdays] = 0;                                      //Reset DSTdays to zero
    DSTyear++;                                        //Increment DSTyear
    DSThour = hourSt;
  }
    if ((DSTyear != 2020) || (DSTyear != 2024) || (DSTyear != 2028) || (DSTyear != 2032) && (DSTdays == 70)){   //Detect leap year
  }
  else{
     DSTdays = 71;  
  }
                                                   //Set to AM if less than 12 hourSt
  if ((hourSt >= 0) && (hourSt <= 11)){    
    lcd.setCursor(14,0); 
    lcd.print("AM");
  }
   else {                                          //Set to PM if 12 or greater hourSt
      lcd.setCursor(14,0); 
      lcd.print("PM");
   }
  if ((DSTdays >= 0) && (DSTdays <= 9)){
    lcd.setCursor(13,1);
    lcd.print("   ");
    lcd.setCursor(15,1);
    lcd.print(DSTdays);
  }
  if ((DSTdays >= 10) && (DSTdays <= 99)){
    lcd.setCursor(13,1);
    lcd.print("   ");
    lcd.setCursor(14,1);
    lcd.print(DSTdays);
  }
  if ((DSTdays >= 100) && (DSTdays <= 366)){
lcd.setCursor(13,1);
lcd.print("   ");
lcd.setCursor(13,1);
lcd.print(DSTdays);      
  }
   readingh = 0;                                //Reset push button #3 to zero HOURS
 }
